// =============================================================================
// Copy.cpp: Implementation of class cCopy
// Filter application, (c) lars.staurset@statkart.no 2003
// =============================================================================

#include <iostream>
#include "Copy.h"
#include "Exception.h"

// =========================================================================
// Public functions
// =========================================================================

// ---------------------------------------------------------------------------
// Class administration (construction, destruction, etc.)
// ---------------------------------------------------------------------------
// Constructor
cCopy::cCopy (const string csInStream, const string csOutStream,
              const bool cbAllowOverwrite, const OutputLevel ceOutputLevel)
: cCommand (csInStream, csOutStream, cbAllowOverwrite, ceOutputLevel)
{
    cout << "Copying from \'" << csInStream << "\' to \'" << csOutStream << "\'\n";
}

// Destructor
cCopy::~cCopy(void)
{
}

// ---------------------------------------------------------------------------
// Data processing
// ---------------------------------------------------------------------------
// Do the job
bool cCopy::Execute ()
{
    bool bException = false;
    string s;
    try {
        while (m_pInStream->ReadLine(&s)) {
            m_pOutStream->WriteLine(s);
        }
    } catch (const cException cE) {
        cout << cE.GetText() << "\n";
        bException = true;
    }
    cout << m_pInStream->GetLineCount() << " lines were copied\n";
    return bException;
}
