// =============================================================================
// Exception.h: Declarations of class cException
// Filter application, (c) lars.staurset@statkart.no 2003
// Purpose: Handle exceptions
// =============================================================================

#pragma once
#include <string>
using namespace std;

class cException
{
    // =========================================================================
    // Public functions
    // =========================================================================
public:
    // ---------------------------------------------------------------------------
    // Class administration (construction, destruction, etc.)
    // ---------------------------------------------------------------------------
    // Constructor with simple text
    cException (const string);

    // Constructor with text as format string with 1 parameter
    cException (const char *, const int);

    // Constructor with text as format string with 2 parameters
    cException (const char *, const string, const string);

    // Constructor with text as format string with 3 parameters
    cException (const char *, const string, const string, const string);

    ~cException (void);

    // ---------------------------------------------------------------------------
    // Data processing
    // ---------------------------------------------------------------------------
    // Return text to caller
    string GetText() const {return m_sText;}

    // =========================================================================
    // Private data members
    // =========================================================================
private:
    string m_sText;          // Message text
};
