// =============================================================================
// InStream.h: Declarations of class cInStream
// Filter application, (c) lars.staurset@statkart.no 2003
// Purpose: Handle reading from a stream
// =============================================================================

#pragma once
#include <fstream>
using namespace std;
#include "Typedefs.h"

class cInStream
{
    // =========================================================================
    // Public functions
    // =========================================================================
public:
    // ---------------------------------------------------------------------------
    // Class administration (construction, destruction, etc.)
    // ---------------------------------------------------------------------------
    cInStream (
        const string,           // File name or path
        const OutputLevel);     // Output level, see Typedefs.h
    ~cInStream (void);

    // ---------------------------------------------------------------------------
    // Data processing
    // ---------------------------------------------------------------------------
    // Read a line
    // Throws a cException if read failure
    bool ReadLine (       // returns true while not EOF
       string *);               // Line contents

   // Number of lines handled
    int GetLineCount() const { return m_nLineCount; }

    // =========================================================================
    // Private data members
    // =========================================================================
private:
    // ---------------------------------------------------------------------------
    // Members passed from client class
    // ---------------------------------------------------------------------------
    OutputLevel m_eOutputLevel;    // Output level, see Typedefs.h

    // ---------------------------------------------------------------------------
    // Members proper to this class
    // ---------------------------------------------------------------------------
    int m_nLineCount;           // Number of lines handled
    ifstream *m_pStream;        // Stream object
};
