// =============================================================================
// Mbox.h: Declarations of class cMbox
// Filter application, (c) lars.staurset@statkart.no 2003
// Purpose: Remove attachments from an Mbox file (mail folder)
// =============================================================================

#pragma once
#include "Command.h"

class cMbox : public cCommand
{
    // =========================================================================
    // Public functions
    // =========================================================================
public:
    // ---------------------------------------------------------------------------
    // Class administration (construction, destruction, etc.)
    // ---------------------------------------------------------------------------
    // Constructor
    // Success: Input and output streams were opened and ready for use
    // Failure: Throws a cException
    cMbox (
        const string,           // Input stream
        const string,           // Output stream
        const bool,             // true if overwriting is allowed
        const OutputLevel);     // Output level, see Typedefs.h

    ~cMbox(void);

    // ---------------------------------------------------------------------------
    // Data processing
    // ---------------------------------------------------------------------------
    // Do the job
    // Success: Input stream was processed
    // Failure: returns false
    bool Execute ();    // return true if successful

    // =========================================================================
    // Private functions
    // =========================================================================
private:

    // Read a line
    // Any cExceptions are caught and reported
    bool ReadLine (         // returns true while not EOF or exception
       string *,                // Line contents
       bool &);                 // true if an exception was caught

    // Split output string in max 80-character lines
    void Output (
        const string)   // String with words separated by spaces
        const;
};
