// =============================================================================
// OutStream.h: Declarations of class cOutStream
// Filter application, (c) lars.staurset@statkart.no 2003
// Purpose: Handle writing to a stream
// =============================================================================

#pragma once
#include <fstream>
using namespace std;
#include "Typedefs.h"

class cOutStream
{
    // =========================================================================
    // Public functions
    // =========================================================================
public:
    // ---------------------------------------------------------------------------
    // Class administration (construction, destruction, etc.)
    // ---------------------------------------------------------------------------
    cOutStream (
        const string,           // File name or path
        const bool,             // true if overwriting is allowed
        const OutputLevel);     // Output level, see Typedefs.h
    ~cOutStream();

    // ---------------------------------------------------------------------------
    // Data processing
    // ---------------------------------------------------------------------------
    // Write a line
    void WriteLine (
        const string);          // Line contents

    // Number of lines handled
    int GetLineCount() const { return m_nLineCount; }

    // =========================================================================
    // Private data members
    // =========================================================================
private:
    // ---------------------------------------------------------------------------
    // Members passed from client class
    // ---------------------------------------------------------------------------
    OutputLevel m_eOutputLevel;    // Output level, see Typedefs.h

    // ---------------------------------------------------------------------------
    // Members proper to this class
    // ---------------------------------------------------------------------------
    int m_nLineCount;           // Number of lines handled
    ofstream *m_pStream;        // Stream object
};
