// =============================================================================
// Typedefs.h: Declarations of common variable types, etc.
// Filter application, (c) lars.staurset@statkart.no 2003
// =============================================================================

#pragma once

// Content-type of message header
typedef enum {
    CT_Unknown,             // Unknown or non-applicable Content-Type
    CT_Related,             // Multipart-Related
    CT_Mixed,               // Multipart-Mixed
    CT_Report,              // Multipart-Report
    CT_Alternative          // Multipart-Alternative
} ContentType;

// Output level
typedef enum {
    OL_Quiet = 0,           // Only summary info
    OL_Normal = 1,          // A few lines for each message
    OL_Verbose = 2,         // Complete message headers
    OL_Debug = 3,           // Verbose + debug info
    OL_Dump = 4             // Very detailed debug info
} OutputLevel;